<?php
session_start();
// 登录判断
if (empty($_SESSION['apiword'])) {
    echo '<script>alert("请先登录~");window.location.href="index.php";</script>';
    exit;
}
function is_https() {
    if ( !empty($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS']) !== 'off') {
        return true;
    } elseif ( isset($_SERVER['HTTP_X_FORWARDED_PROTO']) && $_SERVER['HTTP_X_FORWARDED_PROTO'] === 'https' ) {
        return true;
    } elseif ( !empty($_SERVER['HTTP_FRONT_END_HTTPS']) && strtolower($_SERVER['HTTP_FRONT_END_HTTPS']) !== 'off') {
        return true;
    }
    return false;
}
// 接口生成
require_once 'php/apiword.php';
$obj = new ApiWord();
// 获取配置
$config = $obj->get_config();
?>

<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8">
        <title>消息中心</title>
        <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
        <meta name="renderer" content="webkit">

        <link href="css/font-awesome.min.css" rel="stylesheet" type="text/css">
        <link rel="stylesheet" href="js/CodeMirror/codemirror.css">
        <link href="css/page.css?v=1.0.4" rel="stylesheet" type="text/css">
        <link href="css/main.css?v=1.0.4" rel="stylesheet" type="text/css">

        <script src="https://www.jq22.com/jquery/jquery-2.1.1.js"></script>
        <script src="layui/layui.all.js"></script>  
        <link href="layui/css/layui.css?v=1.0.4" rel="stylesheet" type="text/css">

        <style>
        .content {
            width: initial;
            max-width: initial;
        }
        .site-h1 {
            margin-bottom: 20px;
            line-height: 60px;
            padding-bottom: 10px;
            color: #393D49;
            border-bottom: 1px solid #eee;
            font-size: 28px;
            font-weight: 300;
        }
        .layui-form-item{
            clear: inherit;
        }
        .content h3 {
            margin: 5px 0 1.2em 50px;
        }
        a cite {font-size: 20px;}
        </style>

    </head>
    <body>

<div id="j_taskcenter" class="main">
 <div class="j_mainscroll mCus-mh100 scrollwrapper mCustomScrollbar _mCS_11 mCS_no_scrollbar">
  <div class="mCustomScrollBox mCS-darkblue mCSB_vertical mCSB_inside" id="mCSB_11" tabindex="0">
   <div dir="ltr" style="position:relative; top:0; left:0;" class="mCSB_container mCS_y_hidden mCS_no_scrollbar_y" id="mCSB_11_container">
    <div class="main-bd sidebar-in j_sidebarPren">
     <div class="table-tray scrollwrapper">
      <div class="main-content">


<div id="main" class="fix-sidebar">
    <div class="sidebar" style=" top: 0;">
        <div class="sidebar-inner">
            <div class="list">
                <a class="become-backer" href="index.php">文档列表</a>

                <a class="become-backer">
                    消息中心
                </a>                
            </div>
        </div>
    </div>

    <div class="content guide with-sidebar index-guide">
        <h1 class="site-h1">日数据统计</h1>
        <div class="layui-carousel layadmin-carousel layadmin-backlog" style="width: 100%; height: 200px;">
            <div carousel-item="">
                <ul class="layui-row layui-col-space10 layui-this">
                <li class="layui-col-xs6">
                    <a class="layadmin-backlog-body">
                        <h3>成功次数</h3>
                        <p><cite id="success">0</cite></p>
                    </a>
                </li>
                <li class="layui-col-xs6">
                    <a class="layadmin-backlog-body">
                        <h3>失败次数</h3>
                        <p><cite id="error">0</cite></p>
                    </a>
                </li>
                <li class="layui-col-xs6">
                    <a class="layadmin-backlog-body">
                        <h3>成功率</h3>
                        <p><cite id="success_rate">0%</cite></p>
                    </a>
                </li>
                <li class="layui-col-xs6">
                    <a class="layadmin-backlog-body">
                        <h3>失败率</h3>
                        <p><cite id="error_rate">0%</cite></p>
                    </a>
                </li>
                </ul>
            </div>
        </div>

        <h1 class="site-h1">历史记录</h1>
        <form class="layui-form" action="">
            <div class="layui-form-item" style="width:200px;float:left">
                <label class="layui-form-label">事件</label>
                <div class="layui-input-block">
                    <input type="text" id="action" placeholder="事件" class="layui-input">
                </div>
            </div>
            <div class="layui-form-item" style="width:200px;float:left">
                <label class="layui-form-label">FD</label>
                <div class="layui-input-block">
                    <input type="text" id="fd" placeholder="FD" class="layui-input">
                </div>
            </div>
            
            <div class="layui-form-item" style="width:200px;float:left">
                <label class="layui-form-label">开始时间</label>
                <div class="layui-input-block">
                    <input type="text" id="start_time" placeholder="开始时间" class="layui-input" autocomplete="off">
                </div>
            </div>
            <div class="layui-form-item" style="width:200px;float:left">
                <label class="layui-form-label">结束时间</label>
                <div class="layui-input-block">
                    <input type="text" id="end_time" placeholder="结束时间" class="layui-input" autocomplete="off">
                </div>
            </div>

            <div class="layui-form-item" style="width:200px;float:left">
                <div class="layui-input-block">
                <button class="layui-btn layui-btn-normal" type="button" onclick="get_table(1);">立即搜索</button>
                </div>
            </div>
        </form>
        <div>
            <table class="layui-table">
                <thead>
                    <tr>
                        <th>ID</th>
                        <th>事件</th>
                        <th>FD</th>
                        <th>上一次重发时间</th>
                        <th>重发次数</th>
                        <th>操作</th>
                    </tr> 
                </thead>
                <tbody id="content">
                    
                </tbody>
            </table>
        </div>
        <div id="page"></div>

        
        <h1 class="site-h1">月数据报表</h1>
        <form class="layui-form" style="height: 30px;">
            <div class="layui-form-item" style="width:200px;float:left">
                <label class="layui-form-label">年</label>
                <div class="layui-input-block">
                    <select id="nian" class="layui-input">
                        <?php
                            $yue = date('n',time());
                            $start = date('Y',time());
                            $end = $start-10;
                            for ($i=$start; $i>=$end; $i--) {
                        ?>
                            <option value="<?php echo $i;?>"><?php echo $i;?>年</option>
                        <?php
                            } 
                        ?>
                    </select>
                </div>
            </div>
            <div class="layui-form-item" style="width:200px;float:left">
                <label class="layui-form-label">月</label>
                <div class="layui-input-block">
                    <select id="yue" class="layui-input">
                        <option value="01" <?php if ($yue == 1){ echo 'selected';}?>>1月</option>
                        <option value="02" <?php if ($yue == 2){ echo 'selected';}?>>2月</option>
                        <option value="03" <?php if ($yue == 3){ echo 'selected';}?>>3月</option>
                        <option value="04" <?php if ($yue == 4){ echo 'selected';}?>>4月</option>
                        <option value="05" <?php if ($yue == 5){ echo 'selected';}?>>5月</option>
                        <option value="06" <?php if ($yue == 6){ echo 'selected';}?>>6月</option>
                        <option value="07" <?php if ($yue == 7){ echo 'selected';}?>>7月</option>
                        <option value="08" <?php if ($yue == 8){ echo 'selected';}?>>8月</option>
                        <option value="09" <?php if ($yue == 9){ echo 'selected';}?>>9月</option>
                        <option value="10" <?php if ($yue == 10){ echo 'selected';}?>>10月</option>
                        <option value="11" <?php if ($yue == 11){ echo 'selected';}?>>11月</option>
                        <option value="12" <?php if ($yue == 12){ echo 'selected';}?>>12月</option>
                    </select>
                </div>
            </div>
            
            <div class="layui-form-item" style="width:200px;float:left">
                <div class="layui-input-block">
                <button class="layui-btn layui-btn-normal" type="button" onclick="ajax_btn()">立即搜索</button>
                </div>
            </div>
        </form>
        <div id="echarts" style="width: 100%;height:400px;"></div>


    </div>

</div>   


      </div>
     </div>
    </div>
   </div>
  </div>
 </div>
</div>


<script src="js/echarts.min.js"></script>  

<script>
// 获取接口配置
<?php 
$server = $_SERVER['SERVER_NAME'];
if ($config['websocket_crt_path']){
    $url = 'https://'.$server.':'.$config['websocket_port'];
} else {
    $url = 'http://'.$server.':'.$config['websocket_port'];
}
echo 'var host = "'.$url.'";';
echo 'var api_key = "'.$config['websocket_api_key'].'";';
?>
var laypage;
var form;
layui.use(['form', 'laydate', 'laypage'], function(){
  form = layui.form;
  var laydate = layui.laydate;
  laypage = layui.laypage;
  form.render(); //更新全部

  laydate.render({
    elem: '#start_time'
  });
  laydate.render({
    elem: '#end_time'
  });
});
get_table(1);
// 历史数据
function get_table(page) {
    var data = {
        limit:10,
        page:page,
        action:$('#action').val(),
        fd:$('#fd').val(),
        start_time:$('#start_time').val(),
        ebd_time:$('#ebd_time').val(),
    };
    var array = ajax_get('/message_center/get_list', data);
    if (array['code'] != 200) {
        layer.msg(array['msg'], {icon: 2});
        return false;
    }
    var list = array['data']['list'];
    var num = list.length;
    var html = '';
                  
    for (var i=0; i<num; i++) {
        html += '<tr>';
        html += '<td>'+list[i]['id']+'</td>';
        html += '<td>'+list[i]['action']+'</td>';
        html += '<td>'+list[i]['fd']+'</td>';
        html += '<td>'+timestampToTime(list[i]['create_time'])+'</td>';
        html += '<td>'+list[i]['num']+'</td>';
        html += '<td>';
        html += '<button type="button" class="layui-btn layui-btn-xs layui-btn-warm" onclick="get_resend('+list[i]['id']+')">重发</button>';
        html += '<button type="button" class="layui-btn layui-btn-xs layui-btn-normal" onclick="get_content('+list[i]['id']+')">内容</button>';
        html += '</td>';
        html += '<td style="display:none" id="d-'+list[i]['id']+'">'+list[i]['data']+'</td>';
        html += '</tr>';
    }
    $('#content').html(html);
    // 只有1开始，才能初始化分页插件
    if (page == 1) {
        laypage.render({
            elem: 'page'
            ,limit: 10
            ,count: array['data']['total']*10
            ,jump: function(obj, first){
                if (!first) {
                    get_table(obj.curr);
                }
            }
        });
    }
}
// 加载图表
ajax_btn();
function ajax_btn() {
    var array = ajax_get('/message_center/get_rate_chart', {
        "date": $('#nian').val()+'-'+$('#yue').val()
    });
    if (array['code'] != 200) {
        layer.msg(array['msg'], {icon: 2});
        return false;
    }
    var colors = ['#5793f3', '#d14a61', '#675bba'];
    option = {
        color: colors,

        tooltip: {
            trigger: 'none',
            axisPointer: {
                type: 'cross'
            }
        },
        legend: {
            data:['成功 次数', '失败 次数']
        },
        grid: {
            top: 70,
            bottom: 50
        },
        xAxis: [
            {
                type: 'category',
                axisTick: {
                    alignWithLabel: true
                },
                axisLine: {
                    onZero: false,
                    lineStyle: {
                        color: colors[1]
                    }
                },
                axisPointer: {
                    label: {
                        formatter: function (params) {
                            return '成功 次数  ' + params.value
                                + (params.seriesData.length ? '：' + params.seriesData[0].data : '');
                        }
                    }
                },
                data: array['data']['date']
            },
            {
                type: 'category',
                axisTick: {
                    alignWithLabel: true
                },
                axisLine: {
                    onZero: false,
                    lineStyle: {
                        color: colors[0]
                    }
                },
                axisPointer: {
                    label: {
                        formatter: function (params) {
                            return '失败 次数  ' + params.value
                                + (params.seriesData.length ? '：' + params.seriesData[0].data : '');
                        }
                    }
                },
                data: array['data']['date']
            }
        ],
        yAxis: [
            {
                type: 'value'
            }
        ],
        series: [
            {
                name: '成功',
                type: 'line',
                xAxisIndex: 1,
                smooth: true,
                data: array['data']['success']
            },
            {
                name: '失败',
                type: 'line',
                smooth: true,
                data: array['data']['error']
            }
        ]
    };
    // 基于准备好的dom，初始化echarts实例
    var myChart = echarts.init(document.getElementById('echarts'));
    // 使用刚指定的配置项和数据显示图表。
    myChart.setOption(option);
}

// 加载今日数据
var array = ajax_get('/message_center/get_rate', {
    "date": "<?php echo date('Y-m-d', time());?>"
});
if (array['code'] == 200) {
    $('#success').html(array['data']['success']);
    $('#error').html(array['data']['error']);
    $('#success_rate').html(array['data']['success_rate']+'%');
    $('#error_rate').html(array['data']['error_rate']+'%');
} else {
    layer.msg(array['msg'], {icon: 2});
}

// 重发
function get_resend(id) {
    layer.confirm('确认重新推送该条记录？<br/><font color="red">注意:：如果您已重启过服务，可能该FD已不是之前的用户标识，请小心使用！</font>', {icon: 3, title:'提示'}, function(index){
        var data = {
            id:id,
        };
        var array = ajax_get('/message_center/get_resend', data);
        if (array['code'] != 200) {
            layer.msg(array['msg'], {icon: 2});
        } else {
            layer.msg(array['msg'], {icon: 1});
        }
        layer.close(index);
    });
}
// 查看内容
function get_content(id) {
    var html = $('#d-'+id).html();
    layer.open({
      title: '记录data',
      area: ['50%', '50%'],
      content: '<pre>'+JSON.stringify(eval('('+html+')'), null, 4)+'</pre>'
});
}

function ajax_get(url, data) {
    var index = layer.load(1, {
        shade: [0.1,'#fff']
    });
    var array;
    $.ajax({
        type: 'GET',
        data:data,
        async: false,
        url: host+url,
        contentType: "application/x-www-form-urlencoded;charset=utf-8",
        headers: {
            "api_key":api_key,
        },
        success: function(data) {
            layer.close(index);
            array = eval('('+data+')');
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            layer.close(index);
        }
    });
    return array;
}


//时间戳转日期
function timestampToTime(timestamp) {
    var date = new Date(timestamp * 1000);//时间戳为10位需*1000，时间戳为13位的话不需乘1000
    Y = date.getFullYear() + '-';
    M = (date.getMonth()+1 < 10 ? '0'+(date.getMonth()+1) : date.getMonth()+1) + '-';
    D = date.getDate() + ' ';
    h = date.getHours() + ':';
    m = (date.getMinutes() < 10 ? '0'+(date.getMinutes()) : date.getMinutes()) + ':';
    s = (date.getSeconds() < 10 ? '0'+(date.getSeconds()) : date.getSeconds());
    return Y+M+D+h+m+s;
}
</script>